package cn.yyxx.columbus.core.impl.login.fragment

import android.os.Bundle
import android.text.InputType
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.ImageView
import android.widget.TextView
import androidx.fragment.app.Fragment
import cn.yyxx.columbus.core.entity.ClickType
import cn.yyxx.columbus.core.impl.SdkBridgeImpl
import cn.yyxx.columbus.core.impl.login.LoginActivity
import cn.yyxx.columbus.core.ui.EventEditText
import cn.yyxx.columbus.core.ui.dialog.AgreementDialog
import cn.yyxx.support.ResUtils

/**
 * @author #Suyghur.
 * Created on 2021/06/18
 */
class LauncherFragment : Fragment(), View.OnClickListener {

    private lateinit var mView: View

    private lateinit var loginImpl: LoginActivity

    private lateinit var eetAccount: EventEditText
    private lateinit var eetPwd: EventEditText

    private lateinit var tvForget: TextView

    private lateinit var btnLauncher: Button

    private lateinit var ivCheck: ImageView
    private lateinit var tvAgreement: TextView

    private lateinit var ivGoogle: ImageView
    private lateinit var ivFacebook: ImageView
    private lateinit var ivGuest: ImageView

    private var imgUp = 0
    private var imgDown = 0
    private var imgShow = 0
    private var imgHide = 0
    private var imgCheck = 0
    private var imgUnCheck = 0

    private var check = true
    private var isShowText = false

    private var agreementDialog: AgreementDialog? = null


    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        super.onCreateView(inflater, container, savedInstanceState)
        loginImpl = requireActivity() as LoginActivity
        mView = inflater.inflate(ResUtils.getResId(requireActivity(), "yyxx_login_launcher", "layout"), container, false)
        initView(mView)
        return mView
    }

    private fun initView(view: View) {
        imgUp = ResUtils.getResId(requireActivity(), "yyxx_pack_up_img", "drawable")
        imgDown = ResUtils.getResId(requireActivity(), "yyxx_pack_down_img", "drawable")
        imgShow = ResUtils.getResId(requireActivity(), "yyxx_show_img", "drawable")
        imgHide = ResUtils.getResId(requireActivity(), "yyxx_hide_img", "drawable")
        imgCheck = ResUtils.getResId(requireActivity(), "yyxx_check_img", "drawable")
        imgUnCheck = ResUtils.getResId(requireActivity(), "yyxx_uncheck_img", "drawable")

        eetAccount = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_eet_account", "id"))
        eetAccount.apply {
            leftImageView.setBackgroundResource(ResUtils.getResId(requireActivity(), "yyxx_account_img", "drawable"))
            leftImageView.visibility = View.VISIBLE
            editText.setHint(ResUtils.getResId(requireActivity(), "yyxx_hint_account", "string"))
            rightImageView.setOnClickListener {
                //changeAccountList()
            }
        }

        eetPwd = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_eet_pwd", "id"))
        eetPwd.apply {
            leftImageView.setBackgroundResource(ResUtils.getResId(requireActivity(), "yyxx_pwd_img", "drawable"))
            leftImageView.visibility = View.VISIBLE
            editText.setHint(ResUtils.getResId(requireActivity(), "yyxx_hint_pwd", "string"))
            rightImageView.setBackgroundResource(imgShow)
            rightImageView.visibility = View.VISIBLE
            rightImageView.setOnClickListener {
                if (!isShowText) {
                    isShowText = true
                    rightImageView.setBackgroundResource(imgHide)
                    editText.inputType = InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD
                } else {
                    isShowText = false
                    rightImageView.setBackgroundResource(imgShow)
                    editText.inputType = InputType.TYPE_TEXT_VARIATION_PASSWORD or InputType.TYPE_CLASS_TEXT
                }
                editText.setSelection(editText.length())
            }
        }

        tvForget = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_tv_forget", "id"))

        btnLauncher = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_btn_launcher", "id"))

        ivCheck = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_iv_check", "id"))
        tvAgreement = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_tv_agreement", "id"))
        if (SdkBridgeImpl.initBean.privacyCfg.switch == 0) {
            ivCheck.visibility = View.GONE
            tvAgreement.visibility = View.GONE
        } else {
            ivCheck.visibility = View.VISIBLE
            tvAgreement.visibility = View.VISIBLE
        }

        ivGoogle = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_iv_google", "id"))
        ivFacebook = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_iv_facebook", "id"))
        ivGuest = view.findViewById(ResUtils.getResId(requireActivity(), "yyxx_iv_guest", "id"))

        initViewAction()
        initViewListener()
    }

    private fun initViewAction() {
        tvForget.tag = ClickType.ACTION_FORGET
        btnLauncher.tag = ClickType.ACTION_LAUNCHER
        ivCheck.tag = ClickType.ACTION_CLICK_CHECK
        tvAgreement.tag = ClickType.ACTION_CLICK_AGREEMENT
        ivGoogle.tag = ClickType.ACTION_GOOGLE_MODE
        ivFacebook.tag = ClickType.ACTION_FACEBOOK_MODE
        ivGuest.tag = ClickType.ACTION_GUEST_MODE
    }

    private fun initViewListener() {

        tvForget.setOnClickListener(this)
        btnLauncher.setOnClickListener(this)
        ivCheck.setOnClickListener(this)
        tvAgreement.setOnClickListener(this)
        ivGoogle.setOnClickListener(this)
        ivFacebook.setOnClickListener(this)
        ivGuest.setOnClickListener(this)

    }

    private fun changeCheck() {
        if (check) {
            check = false
            ivCheck.setBackgroundResource(imgUnCheck)
        } else {
            check = true
            ivCheck.setBackgroundResource(imgCheck)
        }
    }

    override fun onClick(v: View?) {
        v?.apply {
            when (tag as Int) {
//                ClickType.ACTION_FORGET->
//                ClickType.ACTION_LAUNCHER->
                ClickType.ACTION_CLICK_CHECK -> changeCheck()
                ClickType.ACTION_CLICK_AGREEMENT -> {
                    agreementDialog?.apply {
                        dismiss()
                        agreementDialog = null
                    }
                    agreementDialog = AgreementDialog(requireContext(), SdkBridgeImpl.initBean.privacyCfg.url)
                    agreementDialog?.show()
                }
                ClickType.ACTION_GOOGLE_MODE -> loginImpl.userSignInImpl.googleLogin(requireActivity())
                ClickType.ACTION_FACEBOOK_MODE -> loginImpl.userSignInImpl.facebookLogin(requireActivity())

            }
        }
    }
}